<?php
require_once('XMLParser.php');

abstract class BasicModel {
	/**
	 *
	 * @param string $filename
	 * @param string|array $classmap
	 * @return bool|array
	 */
	static public function byFilename($filename, $classmap, $simplify=true) {
		$parser = new XMLParser();
		$arr = $parser->parseByFilename($filename, $simplify);
		$entries = array();
		foreach ($arr as $key => $value) {
			$classname = null;
			if (is_string($classmap)) {
				$classname = $classmap;
			} else if (is_array($classmap)) {
#print "key: {$key}; classname: {$classname}<br>\n";
				if (array_key_exists($key, $classmap)) {
					$classname = $classmap[$key];
				}
			}

			if (!is_null($classname)) {
				if (is_string($classmap)) {
					$entries[] = new $classname($value);
				} else {
					if (!is_array($value) && !array_key_exists(0, $value)) {
						$value = array($value);
					}
					foreach ($value as $data) {
						$entries[$classname][] = new $classname($data);
					}
				}
			} else {
				$entries[$key] = $value;
			}
		}
		unset ($arr);
		return $entries;
	}
}
?>
